<meta name="GENERATOR" CONTENT="TtH 2.73">
                                                                                             

<title> PERCEPS Coding Standards</title>
 
<h1 align="center">PERCEPS Coding Standards </h1>

<p>
<h2>Contents</h2>
PERCEPS is the Perl C++ Surveyor, created by Mark Peskin and currently maintained
by Tom Bryan. It is an automatic documentation generator for C++. PERCEPS is
a Perl script designed to parse C/C++ header files and automatically generate
documentation in a variety of formats based on the class definitions, declarations,
and comment information found in those files. Using this tool allows programmers
to comment their code and generate useful documentation at the same time with
no extra effort.

<p>
Because of the flexable nature of PERCEPS, each project is responsible for providing
their set of filters. This document describes the filters that the LDAS project
has adopted as their set.

<p>
Each class, function, or method can be preceeded by a comment. The special tag
of colon (:) specifies that the text to follow is a short description. Following
this optional tag can be lines giving a more detailed explanation. Lastly comes
a group of lines preceeded by tags.

<p>
Filters are applied when a tag is seen. All tags must appear at the beginning
of a C or C++ comment, start with an exclamation mark(!), and end with a colon
(:). No white space characters are allowed between the comment specifier and
the exclamation mark. If the text exceeds a single line, then the the first
character on the following line should be a plus (+). For example:

<p>

<blockquote>//!param: parameter - multi line descriptive text

<br>
//+ for a single parameter.
</blockquote>
Multiple white spaces are compressed into a single white space.

<p>

<ol type="1">
<li> !exc: - Describe exception that can be thrown. The name of the exception and
the description text must be separated by a hyphen (-).

<p>

<ol type="a">
<li> ex: //!exc: exception - explanation of exception.
</ol>
<p>

<li> !ignore_begin:/!ignore_end - Ignore a block of code. This becomes helpful
in header files and swig files where more outside information is required for
proper code compilation, but the information is not available for documentation
purposes.

<p>

<ol type="a">
<li> Ignoring namespace declarations
</ol>
<p>

<blockquote>#ifndef HEADER_H<br>
#define HEADER_H<br>
//!ignore_begin:<br>
namespace ILwd<br>
{<br>
LdasContainer;<br>
}; // namespace - ILwd<br>
//!ignore_end:<br>
//: Class description<br>
class C {};<br>
#endif /* HEADER_H */
</blockquote>

<li> !param: - Declaration and explanation of a parameter. The name of the parameter
and the description text must be separated by a hyphen (-).

<p>

<ol type="a">
<li> ex: //!param: variable - explanation of variable.
</ol>
<p>

<li> !ppp: - Consecutive lines that contain this tag will be concatenated together
and interpreted (with the tag removed) as a perl command. This allows for any
special preprocessing of the data that may need to occur. The example below
shows how one would extend PERCEPS preprocessing by evaluating the file ``swig_rules.pl''
from the source directory.

<p>

<ol type="a">
<li> //!ppp: eval `cat $ENV{SRCDIR}/swig_rules.pl`
</ol>
<p>

<li> !return: - Describe the type of data returned by a function or method.

<p>

<ol type="a">
<li> ex: //!return: bool - True when valid, false otherwise.
</ol>
<p>

<li> !todo: - Specify actions or issues which still need to be addressed.

<p>

<ol type="a">
<li> ex: //!todo: Need to finish documenting class.
</ol>
<p>

<li> !usage: - Show the usage model for TCL programmers.

<p>

<ol type="a">
<li> ex: //!usage: set objptr [ new_Object ]

<li> ex: //!usage: set retval [ Object_Method $objptr Arg1 ]
</ol>
<p>

<li> !usage_ooi: - Show the object oriented usage model for TCL programmers.

<p>

<ol type="a">
<li> ex: //!usage_ooi: Object objptr

<li> ex://!usage_ooi: set retval [ objptr Method Arg1 ]</ol>
</ol>
<p>

<br><br><hr><small>File translated from
T<sub><font size="-1">E</font></sub>X
by <a href="<a href=http://hutchinson.belmont.ma.us/tth/>http://hutchinson.belmont.ma.us/tth/</a>">
T<sub><font size="-1">T</font></sub>H</a>,
version 2.73.<br>On 15 Mar 2001, 15:35.</small>
</html>
